/*
 * main.c
 *
 *  Created on: 3 May 2021
 *      Author: mr_halfword
 */
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <sstream>
#include <iomanip>



class test_class
{
public:
    test_class();
    unsigned int get_initialised (void) const;

private:
    unsigned int initialised;
};

test_class::test_class()
{
    initialised = 0xfeedabba;
}

unsigned int test_class::get_initialised() const
{
    return initialised;
}

test_class global_instance;


#ifdef __EXCEPTIONS
double division(int var1, int var2)
{
  if (var2 == 0)
  {
    throw "Division by Zero.";
  }
  return (var1 / var2);
}
#endif


int main (void)
{
    test_class stack_instance;
     std::stringstream ss;
     volatile float float_in = 123.45f;
     volatile double double_in = 123.456789;

     ss << "\nC++ test\n";
     ss << "global_instance.initialised=0x" << std::hex << global_instance.get_initialised() << "\n";
     ss << "stack_instance.initialised=0x" << std::hex << stack_instance.get_initialised() << "\n";
     ss << "sqrtf(" << float_in << ")=" << sqrtf (float_in) << "\n";
     ss << std::setprecision(16) << "sqrt(" << double_in << ")=" << sqrt (double_in) << "\n";
     int a = 30;
     int b = 0;
     double d = 0;
#ifdef __EXCEPTIONS
     try
     {
       d = division(a, b);
       ss << d << "\n\r";
     }
     catch (const char *error)
     {
       ss << error << "\n\r";
     }
#endif
     printf ("%s", (ss.str().c_str()));
     return 0;
}

